RM(1) | General Commands Manual | RM(1)

# NAME

`rm` — remove directory entries

# SYNOPSIS

`rm` | [`-f` | `-i`] [`-dPRrvWx`] file ...

# DESCRIPTION

The `rm` utility attempts to remove the non-directory type files specified on the command line. If the permissions of the file do not permit writing, and the standard input device is a terminal, the user is prompted (on the standard error output) for confirmation.

The options are as follows:

`-d`
  Attempt to remove directories as well as other types of files.
`-f`
  Attempt to remove the files without prompting for confirmation, regardless of the file's permissions. If the file does not exist, do not display a diagnostic message or modify the exit status to reflect an error. The `-f` option overrides any previous `-i` options.
`-i`
  Request confirmation before attempting to remove each file, regardless of the file's permissions, or whether or not the standard input device is a terminal. The `-i` option overrides any previous `-f` options.
`-P`
  Overwrite regular files before deleting them. Files are overwritten three times, first with the byte pattern 0xff, then 0x00, and then with random data, before they are deleted. Some care is taken to ensure that the data are actually written to disk, but this cannot be guaranteed, even on traditional filesystems; on log-structured filesystems or if any block-journaling scheme is in use, this option is completely useless. If the file cannot be overwritten, it will not be removed.
`-R`
  Attempt to remove the file hierarchy rooted in each file argument. The `-R` option implies the `-d` option. If the `-i` option is specified, the user is prompted for confirmation before each directory's contents are processed (as well as before the attempt is made to remove the directory). If the user does not respond affirmatively, the file hierarchy rooted in that directory is skipped.
`-r`
  Equivalent to `-R`.
`-v`
  Cause `rm` to be verbose, showing files as they are processed.
`-W`
  Attempts to undelete the named files. Currently, this option can only be used to recover files covered by whiteouts.
`-x`
  When removing a hierarchy, do not cross mount points.

The `rm` utility removes symbolic links, not the files referenced by the links.

It is an error to attempt to remove the files ``.'' and ``..''.

# EXIT STATUS

The `rm` utility exits 0 if all of the named files or file hierarchies were removed, or if the `-f` option was specified and all of the existing files or file hierarchies were removed. If an error occurs, `rm` exits with a value >0.

# EXAMPLES

`rm` uses getopt(3) standard argument processing. Removing filenames that begin with a dash (e.g., -file) in the current directory which might otherwise be taken as option flags to `rm` can be accomplished as follows:

`rm -- -file`

or

`rm ./-file`

# COMPATIBILITY

The `rm` utility differs from historical implementations in that the `-f` option only masks attempts to remove non-existent files instead of masking a large variety of errors.

Also, historical BSD implementations prompted on the standard output, not the standard error output.

# SEE ALSO

rmdir(1), undelete(2), unlink(2), fts(3), getopt(3), symlink(7)

# STANDARDS

The `rm` utility is expected to be IEEE Std 1003.2 (“POSIX.2”) compatible. The `-v` and `-x` options are extensions.

The `-P` option attempts to conform to U.S. DoD 5220-22.M, "National Industrial Security Program Operating Manual" ("NISPOM") as updated by Change 2 and the July 23, 2003 "Clearing & Sanitization Matrix". However, unlike earlier revisions of NISPOM, the 2003 matrix imposes requirements which make it clear that the standard does not and can not apply to the erasure of individual files, in particular requirements relating to spare sector management for an entire magnetic disk. Because these requirements are not met, the `-P` option does not conform to the standard.

# HISTORY

An `rm` utility appeared in Version 1 AT&T UNIX.

# BUGS

The `-P` option assumes that the underlying file system is a fixed-block file system. FFS is a fixed-block file system, LFS is not. In addition, only regular files are overwritten, other types of files are not. Recent research indicates that as many as 35 overwrite passes with carefully chosen data patterns may be necessary to actually prevent recovery of data from a magnetic disk. Thus the `-P` option is likely both insufficient for its design purpose and far too costly for default operation. However, it will at least prevent the recovery of data from FFS volumes with fsdb(8).

August 12, 2016 | NetBSD 11.99